/*! 
 * @file navigation_data.cpp
 * @brief Data definitions for (De)serialization used mainly by 
 *        GlobalNavigation Component.
 * @author SAGAMI, Tsuyoshi <sagami@brains.co.jp>
 */

#include "navigation_data.h"

namespace NavData {
const char CATEGORY[] = "NavData";
const char COORD_JGD9[] = "JGD2000_9";

//! @def DEF_TYPE_ID(classname)class 名と同一のTYPE_IDを生成するためのマクロ
#define DEF_TYPE_ID(classname) const char classname::TYPE_ID[] = #classname

DEF_TYPE_ID(PotentialGrid);		//!< TYPE_ID定義
DEF_TYPE_ID(PathNodes);			//!< TYPE_ID定義
DEF_TYPE_ID(CommandString);		//!< TYPE_ID定義
DEF_TYPE_ID(TaggedPoint);		//!< TYPE_ID定義

#undef DEF_TYPE_ID




} /* namespace NavData */
/*
 * Local Variables:
 * mode: c++
 * c-basic-offset: 4
 * tab-width: 4
 * indent-tabs-mode: t
 * End:
 *
 */
