#ifndef  _LOCAL_PATH_PLAN_DIALOG_H__
#define  _LOCAL_PATH_PLAN_DIALOG_H__

#pragma once

#include "GridMap.h"
#include "Path.h"

/** ウインドウ処理を初期化する
 *
 * ウインドウ使用前にウインドウシステム, スレッドまわりを初期化する
 *
 * @return 常に0を返す
 */
int initialize_window(void);

/** ウインドウを閉じる
 */
void close_window(void);

/** ウインドウ処理用スレッド
 *
 * @param[in] param スレッド開始時に渡されるパラメータ (未使用)
 */
void* windowThread(void* param);

/** 表示する存在確率マップを設定する
 *
 * @param[in] grid_map 表示する存在確率マップ
 */
//int set_value(struct grid_map_T *grid_map);
int set_value(GridMap *grid_map);

/** 表示する経路情報を設定する
 *
 * @param[in] grid_map 表示する存在確率マップ
 */
int set_value(Path *path);

#endif //_LOCAL_PATH_PLAN_DIALOG_H__
